unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm2 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form2: TForm2;

implementation

Uses zLib;

{$R *.dfm}

procedure TForm2.Button1Click(Sender: TObject);
var
  FileIni, FileOut: TFileStream;
  Zip: TCompressionStream;
begin
  FileIni:=TFileStream.Create(Edit1.Text, fmOpenRead and   fmShareExclusive);
  FileOut:=TFileStream.Create(Edit2.Text, fmCreate or fmShareExclusive);
  Zip:=TCompressionStream.Create(clMax, FileOut);
  Zip.CopyFrom(FileIni, FileIni.Size);
  Zip.Free;
  FileOut.Free;
  FileIni.Free;
  ShowMessage('Arquivo Compactado...');
end;

procedure TForm2.Button2Click(Sender: TObject);
Var
  FileIni, FileOut: TFileStream;
  DeZip: TDecompressionStream;
  i : Integer;
  Buf: array[0..1023]of Byte;
begin
  FileIni:=TFileStream.Create(Edit1.Text, fmOpenRead and fmShareExclusive);
  FileOut:=TFileStream.Create(Edit2.Text, fmCreate or fmShareExclusive);
  DeZip:=TDecompressionStream.Create(FileIni);
  repeat
    i:=DeZip.Read(Buf, SizeOf(Buf));
    if i <> 0 then
      FileOut.Write(Buf, i);
  until i <= 0;
  DeZip.Free;
  FileOut.Free;
  FileIni.free;
  ShowMessage('Arquivo Descompactado...');
end;

end.
